#!/usr/bin/perl
###################################
##  AutoRank Professional v2.1.1 ##
###############################################################################
##  update.cgi                                                               ##
##  ----------                                                               ##
##  This script will update members from 2.0.x database to 2.1.0 database    ##
###############################################################################

###############################################################
##                   DO NOT EDIT THIS FILE                   ##
###############################################################

use strict;
use GDBM_File;

print "Content-type: text/html\n\n";

eval {
  main();
};

if( $@ ) {
  print "<b>Script Error:</b> $@";
}

sub main {
  my %mem;

  require "functions.cgi";
  
  derror("This script needs to be run from a browser") unless( $ENV{'REQUEST_METHOD'} eq "GET" );
  derror("Your database has already been updated!") if( -e "$FUNCTIONS::SCRIPT_DATA_DIR/UPDATE_DONE" );
  
  opendir(MEMBER_DIR, "$VARIABLES::MEMBER_DATA_DIR") || FUNCTIONS::script_error(1003, $VARIABLES::MEMBER_DATA_DIR);
  my @member_files = sort(grep { m/.*\.mdf/ } readdir(MEMBER_DIR));
  closedir(MEMBER_DIR);
  
  dbmopen(%mem, "$FUNCTIONS::SCRIPT_DATA_DIR/members", 0666) || serror("members", $!);

  derror("No members to update!") unless( scalar( @member_files ) );

  for( @member_files ) {
    open(MEM, "$VARIABLES::MEMBER_DATA_DIR/$_") || serror($_, $!);
    my @md = split(/\|/, <MEM>);
    close(MEM);

    my $member = $_;
    $member =~ s/\.mdf//;

    $mem{$member} = "$md[0]|$md[1]|$md[3]|0|0|$md[5]|$md[6]|Misc|$md[4]|$md[8]|$md[7]|$md[9]||1|1|none|0.0.0.0|" . time;
  }

  dbmclose(%mem);

  open(DONE, ">$FUNCTIONS::SCRIPT_DATA_DIR/UPDATE_DONE") || serror("UPDATE_DONE", $!);
  close(DONE);

  print scalar( @member_files ) . " members upgraded to new database system.<br>";
  print "You are now ready to continue your upgrade!";
}

sub derror {
  print "$_[0]";
  exit -1;
}

sub serror {
  print "CGI ERROR<br>Accessing File: $_[0]<br>Cause: $_[1]";
  exit -1;
}
